# Class VulkanVersion.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanVersion.Builder

Enclosing class:
  `VulkanVersion`

public static final class VulkanVersion.Builder extends Object
Builds instances of type `VulkanVersion`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanVersion`
  `build()`
  Builds a new `VulkanVersion`.
  `final VulkanVersion.Builder`
  `from(VulkanVersionType instance)`
  Fill a builder with attribute values from the provided `VulkanVersionType` instance.
  `final VulkanVersion.Builder`
  `setMajor(int major)`
  Initializes the value for the `major` attribute.
  `final VulkanVersion.Builder`
  `setMinor(int minor)`
  Initializes the value for the `minor` attribute.
  `final VulkanVersion.Builder`
  `setPatch(int patch)`
  Initializes the value for the `patch` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanVersion.Builder from(VulkanVersionType instance)
    Fill a builder with attribute values from the provided `VulkanVersionType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMajor

    public final VulkanVersion.Builder setMajor(int major)
    Initializes the value for the `major` attribute.
    Parameters:
      `major` - The value for major
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinor

    public final VulkanVersion.Builder setMinor(int minor)
    Initializes the value for the `minor` attribute.
    Parameters:
      `minor` - The value for minor
    Returns:
      `this` builder for use in a chained invocation

  - ### setPatch

    public final VulkanVersion.Builder setPatch(int patch)
    Initializes the value for the `patch` attribute.
    Parameters:
      `patch` - The value for patch
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanVersion build()
    Builds a new `VulkanVersion`.
    Returns:
      An immutable instance of VulkanVersion
    Throws:
      `IllegalStateException` - if any required attributes are missing